#version 120
#extension GL_EXT_gpu_shader4 : enable
/* DRAWBUFFERS:1 */
varying vec4 color;
varying vec3 texcoord;
uniform sampler2D gaux1;
uniform sampler2D texture;
uniform vec2 texelSize;
uniform vec3 sunVec;
uniform vec4 lightCol;

uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;


vec4 iProjDiag = vec4(gbufferProjectionInverse[0].x, gbufferProjectionInverse[1].y, gbufferProjectionInverse[2].zw);
vec3 toScreenSpaceVector(vec3 p) {
    vec3 p3 = p * 2. - 1.;
    vec4 fragposition = iProjDiag * p3.xyzz + gbufferProjectionInverse[3];
    return normalize(fragposition.xyz);
}


//Mie phase function
float phaseg(float x, float g){
    float gg = g * g;
    return (gg + 1.0) * pow(-2.0 * (g * x) + (gg + 1.0), -1.5);
}
void main() {
  vec3 fragpos = toScreenSpaceVector(vec3(gl_FragCoord.xy*texelSize,1.));
  float SdotV = dot(fragpos,sunVec) * lightCol.a;

  const float g1 = 0.4;
  const float gg1 = g1*g1;
  float phase1 = (gg1 + 1.0) * pow((-2.0 * g1) * SdotV + (gg1 + 1.0), -1.5);


  vec3 lightCol = texelFetch2D(gaux1, ivec2(0, 16), 0).rgb*2.0 + lightCol.rgb * phase1;
  gl_FragData[0] = vec4(lightCol, 1.0) * texture2D(texture, texcoord.xy) * vec4(vec3(texcoord.z), 1.0);
}
